/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 11 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"

#include <cstring>
#include <cctype>
#include <cstdlib>
#include <clocale>
#include <cmath>
#ifdef HAVE_XLOCALE
#include <xlocale.h>
#endif
#include "parser.h"
#include "constants.h"
#include "functions.h"
#if defined(_WIN32)
#define locale_t _locale_t
#define strtod_l _strtod_l
#define freelocale _free_locale
#endif

#include <gsl/gsl_sf_gamma.h>

#ifdef PDEBUG
#include <cstdio>
#define pdebug(...) fprintf(stderr, __VA_ARGS__)
#else
#define pdebug(...) {}
#endif

#define YYERROR_VERBOSE 1

/* params passed to yylex (and yyerror) */
typedef struct param {
	size_t pos;		/* current position in string */
	char* string;		/* the string to parse */
	const char* locale;	/* name of locale to convert numbers */
} param;

int yyerror(param *p, const char *err);
int yylex(param *p);
int _variablesCounter = 0;
bool skipSpecialFunctionEvaluation = false;

int variablesCounter() {
	return _variablesCounter;
}

double res;
char _lastErrorMessage[256] = "";

const char* lastErrorMessage() {
	return _lastErrorMessage;
}

static void wrongArgumentNumberMessage(const char* function_name, int provided, int expected) {
	snprintf(_lastErrorMessage, sizeof(_lastErrorMessage), "Parsing Error: Wrong argument count for %s. Provided: %d, Expected: %d", function_name, provided, expected);
}

static void wrongArgumentInternalErrorMessage(const char* function_name, int expected) {
	snprintf(_lastErrorMessage, sizeof(_lastErrorMessage), "Internal parsing Error: Wrong argument count for %s. Expected: %d , but function does not have this number of arguments", function_name, expected);
}

static void notImplementedError(const char* function_name) {
	snprintf(_lastErrorMessage, sizeof(_lastErrorMessage), "Parsing Error: '%s' not implemented.", function_name);
}

static void yyerrorFunction(const char* function_name, const char* msg) {
	snprintf(_lastErrorMessage, sizeof(_lastErrorMessage), "Parsing Error: In function '%s': %s", function_name, msg);
}

static void yyerror(const char* msg) {
	snprintf(_lastErrorMessage, sizeof(_lastErrorMessage), "Parsing Error: %s", msg);
}




#line 147 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "gsl_parser.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_NUM = 3,                        /* NUM  */
  YYSYMBOL_VAR = 4,                        /* VAR  */
  YYSYMBOL_FNCT = 5,                       /* FNCT  */
  YYSYMBOL_SPECFNCT = 6,                   /* SPECFNCT  */
  YYSYMBOL_OR = 7,                         /* "||"  */
  YYSYMBOL_AND = 8,                        /* "&&"  */
  YYSYMBOL_LE = 9,                         /* "<="  */
  YYSYMBOL_GE = 10,                        /* ">="  */
  YYSYMBOL_11_ = 11,                       /* '='  */
  YYSYMBOL_12_ = 12,                       /* '-'  */
  YYSYMBOL_13_ = 13,                       /* '+'  */
  YYSYMBOL_14_ = 14,                       /* '<'  */
  YYSYMBOL_15_ = 15,                       /* '>'  */
  YYSYMBOL_16_ = 16,                       /* '*'  */
  YYSYMBOL_17_ = 17,                       /* '/'  */
  YYSYMBOL_18_ = 18,                       /* '%'  */
  YYSYMBOL_NEG = 19,                       /* NEG  */
  YYSYMBOL_20_ = 20,                       /* '^'  */
  YYSYMBOL_21_ = 21,                       /* '!'  */
  YYSYMBOL_22_n_ = 22,                     /* '\n'  */
  YYSYMBOL_23_ = 23,                       /* '('  */
  YYSYMBOL_24_ = 24,                       /* ')'  */
  YYSYMBOL_25_ = 25,                       /* ';'  */
  YYSYMBOL_26_ = 26,                       /* ','  */
  YYSYMBOL_27_ = 27,                       /* '|'  */
  YYSYMBOL_YYACCEPT = 28,                  /* $accept  */
  YYSYMBOL_input = 29,                     /* input  */
  YYSYMBOL_line = 30,                      /* line  */
  YYSYMBOL_expr = 31                       /* expr  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   472

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  28
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  4
/* YYNRULES -- Number of rules.  */
#define YYNRULES  45
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  98

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   266


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      22,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    21,     2,     2,     2,    18,     2,     2,
      23,    24,    16,    13,    26,    12,     2,    17,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    25,
      14,    11,    15,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    20,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    27,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    19
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   111,   111,   112,   115,   116,   117,   120,   121,   122,
     123,   150,   177,   204,   231,   260,   261,   262,   263,   264,
     282,   300,   318,   336,   354,   372,   390,   408,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "NUM", "VAR", "FNCT",
  "SPECFNCT", "\"||\"", "\"&&\"", "\"<=\"", "\">=\"", "'='", "'-'", "'+'",
  "'<'", "'>'", "'*'", "'/'", "'%'", "NEG", "'^'", "'!'", "'\\n'", "'('",
  "')'", "';'", "','", "'|'", "$accept", "input", "line", "expr", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-21)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -21,    27,   -21,   -20,   -21,    -4,   -12,   -11,   117,   117,
     -21,   117,   117,   -21,   435,   -21,   117,    53,    82,   -15,
     -15,   363,   173,   117,   117,   117,   117,   117,   117,   117,
     117,    92,   117,   117,   117,   -21,   -21,   451,   -21,   189,
      29,   -21,   249,   -21,   -21,    26,   -15,    26,    26,    26,
      26,    26,    26,   117,   -15,   -15,   -15,   -15,   -21,   117,
     117,   -21,   -21,   122,   -15,   268,   209,    55,   287,   -21,
     117,   -21,   117,   -21,   -21,   127,   306,   229,    57,   325,
     -21,   117,   -21,   117,   -21,   -21,   152,   344,   381,    58,
     399,   -21,   117,   -21,   -21,   -21,   417,   -21
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     0,     7,     8,     0,     0,     0,     0,
       4,     0,     0,     3,     0,     6,     0,     0,     0,    40,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,     5,     9,    19,     0,
       8,    10,     0,    43,    44,    30,    34,    37,    36,    29,
      28,    39,    38,     0,    31,    32,    33,    41,    20,     0,
       0,    11,    15,     0,    42,     0,     0,     8,     0,    24,
       0,    21,     0,    12,    16,     0,     0,     0,     8,     0,
      25,     0,    22,     0,    13,    17,     0,     0,     0,     8,
       0,    26,     0,    23,    14,    18,     0,    27
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -21,   -21,   -21,    -8
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,    13,    14
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      19,    20,    15,    21,    22,    34,    35,    16,    37,    39,
      42,    17,    18,     0,     0,    45,    46,    47,    48,    49,
      50,    51,    52,    54,    55,    56,    57,     2,     3,     0,
       4,     5,     6,     7,    24,     0,     0,     0,     0,     8,
      16,     0,    31,    32,    33,    64,    34,    35,     9,    10,
      11,    65,    66,    61,    12,    68,     4,     5,     6,     7,
       0,     0,    76,     0,    77,     8,    16,    79,    16,    16,
       0,     0,     0,    87,     9,    88,    11,    38,    90,    73,
      12,    84,    94,     0,    96,     4,    40,     6,     7,     0,
       0,     0,     0,     0,     8,     4,     5,     6,     7,     0,
       0,     0,     0,     9,     8,    11,    41,     0,    53,    12,
       0,     0,     0,     9,     0,    11,     0,     0,     0,    12,
       4,     5,     6,     7,     0,     4,    67,     6,     7,     8,
       4,    78,     6,     7,     8,     0,     0,     0,     9,     8,
      11,     0,     0,     9,    12,    11,     0,     0,     9,    12,
      11,     0,     0,     0,    12,     4,    89,     6,     7,     0,
       0,     0,     0,     0,     8,     0,     0,     0,     0,     0,
       0,     0,     0,     9,     0,    11,     0,     0,     0,    12,
      23,    24,    25,    26,     0,    27,    28,    29,    30,    31,
      32,    33,     0,    34,    35,     0,    23,    24,    25,    26,
      44,    27,    28,    29,    30,    31,    32,    33,     0,    34,
      35,     0,     0,    58,    59,    60,    23,    24,    25,    26,
       0,    27,    28,    29,    30,    31,    32,    33,     0,    34,
      35,     0,     0,    71,     0,    72,    23,    24,    25,    26,
       0,    27,    28,    29,    30,    31,    32,    33,     0,    34,
      35,     0,     0,    82,     0,    83,    23,    24,    25,    26,
       0,    27,    28,    29,    30,    31,    32,    33,     0,    34,
      35,     0,     0,    62,    63,    23,    24,    25,    26,     0,
      27,    28,    29,    30,    31,    32,    33,     0,    34,    35,
       0,     0,    69,    70,    23,    24,    25,    26,     0,    27,
      28,    29,    30,    31,    32,    33,     0,    34,    35,     0,
       0,    74,    75,    23,    24,    25,    26,     0,    27,    28,
      29,    30,    31,    32,    33,     0,    34,    35,     0,     0,
      80,    81,    23,    24,    25,    26,     0,    27,    28,    29,
      30,    31,    32,    33,     0,    34,    35,     0,     0,    85,
      86,    23,    24,    25,    26,     0,    27,    28,    29,    30,
      31,    32,    33,     0,    34,    35,     0,     0,    91,    92,
      23,    24,    25,    26,     0,    27,    28,    29,    30,    31,
      32,    33,     0,    34,    35,     0,     0,    43,    23,    24,
      25,    26,     0,    27,    28,    29,    30,    31,    32,    33,
       0,    34,    35,     0,     0,    93,    23,    24,    25,    26,
       0,    27,    28,    29,    30,    31,    32,    33,     0,    34,
      35,     0,     0,    95,    23,    24,    25,    26,     0,    27,
      28,    29,    30,    31,    32,    33,     0,    34,    35,     0,
       0,    97,    23,    24,    25,    26,     0,    27,    28,    29,
      30,    31,    32,    33,     0,    34,    35,    36,    23,    24,
      25,    26,     0,    27,    28,    29,    30,    31,    32,    33,
       0,    34,    35
};

static const yytype_int8 yycheck[] =
{
       8,     9,    22,    11,    12,    20,    21,    11,    16,    17,
      18,    23,    23,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,     0,     1,    -1,
       3,     4,     5,     6,     8,    -1,    -1,    -1,    -1,    12,
      11,    -1,    16,    17,    18,    53,    20,    21,    21,    22,
      23,    59,    60,    24,    27,    63,     3,     4,     5,     6,
      -1,    -1,    70,    -1,    72,    12,    11,    75,    11,    11,
      -1,    -1,    -1,    81,    21,    83,    23,    24,    86,    24,
      27,    24,    24,    -1,    92,     3,     4,     5,     6,    -1,
      -1,    -1,    -1,    -1,    12,     3,     4,     5,     6,    -1,
      -1,    -1,    -1,    21,    12,    23,    24,    -1,    16,    27,
      -1,    -1,    -1,    21,    -1,    23,    -1,    -1,    -1,    27,
       3,     4,     5,     6,    -1,     3,     4,     5,     6,    12,
       3,     4,     5,     6,    12,    -1,    -1,    -1,    21,    12,
      23,    -1,    -1,    21,    27,    23,    -1,    -1,    21,    27,
      23,    -1,    -1,    -1,    27,     3,     4,     5,     6,    -1,
      -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    21,    -1,    23,    -1,    -1,    -1,    27,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    -1,    20,    21,    -1,     7,     8,     9,    10,
      27,    12,    13,    14,    15,    16,    17,    18,    -1,    20,
      21,    -1,    -1,    24,    25,    26,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    16,    17,    18,    -1,    20,
      21,    -1,    -1,    24,    -1,    26,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    16,    17,    18,    -1,    20,
      21,    -1,    -1,    24,    -1,    26,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    16,    17,    18,    -1,    20,
      21,    -1,    -1,    24,    25,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    16,    17,    18,    -1,    20,    21,
      -1,    -1,    24,    25,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    16,    17,    18,    -1,    20,    21,    -1,
      -1,    24,    25,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    16,    17,    18,    -1,    20,    21,    -1,    -1,
      24,    25,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    16,    17,    18,    -1,    20,    21,    -1,    -1,    24,
      25,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      16,    17,    18,    -1,    20,    21,    -1,    -1,    24,    25,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    -1,    20,    21,    -1,    -1,    24,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      -1,    20,    21,    -1,    -1,    24,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    16,    17,    18,    -1,    20,
      21,    -1,    -1,    24,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    16,    17,    18,    -1,    20,    21,    -1,
      -1,    24,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    16,    17,    18,    -1,    20,    21,    22,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      -1,    20,    21
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    29,     0,     1,     3,     4,     5,     6,    12,    21,
      22,    23,    27,    30,    31,    22,    11,    23,    23,    31,
      31,    31,    31,     7,     8,     9,    10,    12,    13,    14,
      15,    16,    17,    18,    20,    21,    22,    31,    24,    31,
       4,    24,    31,    24,    27,    31,    31,    31,    31,    31,
      31,    31,    31,    16,    31,    31,    31,    31,    24,    25,
      26,    24,    24,    25,    31,    31,    31,     4,    31,    24,
      25,    24,    26,    24,    24,    25,    31,    31,     4,    31,
      24,    25,    24,    26,    24,    24,    25,    31,    31,     4,
      31,    24,    25,    24,    24,    24,    31,    24
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    28,    29,    29,    30,    30,    30,    31,    31,    31,
      31,    31,    31,    31,    31,    31,    31,    31,    31,    31,
      31,    31,    31,    31,    31,    31,    31,    31,    31,    31,
      31,    31,    31,    31,    31,    31,    31,    31,    31,    31,
      31,    31,    31,    31,    31,    31
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     2,     2,     1,     1,     3,
       3,     4,     6,     8,    10,     4,     6,     8,    10,     3,
       4,     6,     8,    10,     6,     8,    10,    12,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       2,     3,     4,     3,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (p, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, p); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, param *p)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (p);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, param *p)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, p);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, param *p)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], p);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, p); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, param *p)
{
  YY_USE (yyvaluep);
  YY_USE (p);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (param *p)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (p);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 5: /* line: expr '\n'  */
#line 116 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                      { res=(yyvsp[-1].dval); }
#line 1289 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 6: /* line: error '\n'  */
#line 117 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { yyerrok; }
#line 1295 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 7: /* expr: NUM  */
#line 120 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = (yyvsp[0].dval);                            }
#line 1301 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 8: /* expr: VAR  */
#line 121 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = std::get<double>((yyvsp[0].tptr)->value); _variablesCounter++;}
#line 1307 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 9: /* expr: VAR '=' expr  */
#line 122 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = std::get<double>((yyvsp[-2].tptr)->value) = (yyvsp[0].dval); _variablesCounter++;       }
#line 1313 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 10: /* expr: SPECFNCT '(' ')'  */
#line 123 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                         {
							const auto& special_function = std::get<special_function_def>((yyvsp[-2].tptr)->value);
							if (!special_function.payload.expired() && !special_function.payload.lock()->constant)
								_variablesCounter++;
							const int argc = special_function.funsptr->argc;
							if (argc != 0) {
								wrongArgumentNumberMessage((yyvsp[-2].tptr)->name, 0, argc);
								yynerrs++;
								return 1;
							}
							try {
								const auto function = std::get<func_tPayload>(special_function.funsptr->fnct);
								if (!skipSpecialFunctionEvaluation) {
									if (function == nullptr) {
										notImplementedError((yyvsp[-2].tptr)->name);
										yynerrs++;
										return 2;
									}
									(yyval.dval) = function(special_function.payload);
								} else
									(yyval.dval) = std::nan("0");
							} catch (const std::bad_variant_access& ex) {
								wrongArgumentInternalErrorMessage((yyvsp[-2].tptr)->name, 0);
								yynerrs++;
								return 1;
							}
						}
#line 1345 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 11: /* expr: SPECFNCT '(' VAR ')'  */
#line 150 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                        {
							const auto& special_function = std::get<special_function_def>((yyvsp[-3].tptr)->value);
							if (!special_function.payload.expired() && !special_function.payload.lock()->constant)
								_variablesCounter++;
							const int argc = special_function.funsptr->argc;
							if (argc != 1) {
								wrongArgumentNumberMessage((yyvsp[-3].tptr)->name, 1, argc);
								yynerrs++;
								return 1;
							}
							try {
								const auto function = std::get<func_t1Payload>(special_function.funsptr->fnct);
								if (!skipSpecialFunctionEvaluation) {
									if (function == nullptr) {
										notImplementedError((yyvsp[-3].tptr)->name);
										yynerrs++;
										return 2;
									}
									(yyval.dval) = function((yyvsp[-1].tptr)->name, special_function.payload);
								} else
									(yyval.dval) = std::nan("0");
							} catch (const std::bad_variant_access& ex) {
								wrongArgumentInternalErrorMessage((yyvsp[-3].tptr)->name, 1);
								yynerrs++;
								return 1;
							}
						}
#line 1377 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 12: /* expr: SPECFNCT '(' expr ';' VAR ')'  */
#line 177 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                 {
									const auto& special_function = std::get<special_function_def>((yyvsp[-5].tptr)->value);
									if (!special_function.payload.expired() && !special_function.payload.lock()->constant)
										_variablesCounter++;
									const int argc = special_function.funsptr->argc;
									if (argc != 2) {
										wrongArgumentNumberMessage((yyvsp[-5].tptr)->name, 2, argc);
										yynerrs++;
										return 1;
									}
									try {
										const auto function = std::get<func_t2Payload>(special_function.funsptr->fnct);
										if (!skipSpecialFunctionEvaluation) {
											if (function == nullptr) {
												notImplementedError((yyvsp[-5].tptr)->name);
												yynerrs++;
												return 2;
											}
											(yyval.dval) = function((yyvsp[-3].dval) ,(yyvsp[-1].tptr)->name, special_function.payload);
										} else
											(yyval.dval) = std::nan("0");
									} catch (const std::bad_variant_access& ex) {
										wrongArgumentInternalErrorMessage((yyvsp[-5].tptr)->name, 2);
										yynerrs++;
										return 1;
									}
								  }
#line 1409 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 13: /* expr: SPECFNCT '(' expr ';' expr ';' VAR ')'  */
#line 204 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                          {
											const auto& special_function = std::get<special_function_def>((yyvsp[-7].tptr)->value);
											if (!special_function.payload.expired() && !special_function.payload.lock()->constant)
												_variablesCounter++;
											const int argc = special_function.funsptr->argc;
											if (argc != 3) {
												wrongArgumentNumberMessage((yyvsp[-7].tptr)->name, 3, argc);
												yynerrs++;
												return 1;
											}
											try {
												const auto function = std::get<func_t3Payload>(special_function.funsptr->fnct);
												if (!skipSpecialFunctionEvaluation) {
													if (function == nullptr) {
														notImplementedError((yyvsp[-7].tptr)->name);
														yynerrs++;
														return 2;
													}
													(yyval.dval) = function((yyvsp[-5].dval), (yyvsp[-3].dval), (yyvsp[-1].tptr)->name, special_function.payload);
												} else
													(yyval.dval) = std::nan("0");
											} catch (const std::bad_variant_access& ex) {
												wrongArgumentInternalErrorMessage((yyvsp[-7].tptr)->name, 3);
												yynerrs++;
												return 1;
											}
										  }
#line 1441 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 14: /* expr: SPECFNCT '(' expr ';' expr ';' expr ';' VAR ')'  */
#line 231 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                                   {
													const auto& special_function = std::get<special_function_def>((yyvsp[-9].tptr)->value);
													if (!special_function.payload.expired() && !special_function.payload.lock()->constant)
														_variablesCounter++;
													const int argc = special_function.funsptr->argc;
													if (argc != 4) {
														wrongArgumentNumberMessage((yyvsp[-9].tptr)->name, 4, argc);
														yynerrs++;
														return 1;
													}
													try {
														const auto function = std::get<func_t4Payload>(special_function.funsptr->fnct);
														if (!skipSpecialFunctionEvaluation) {
															if (function == nullptr) {
																notImplementedError((yyvsp[-9].tptr)->name);
																yynerrs++;
																return 2;
															}
															(yyval.dval) = function((yyvsp[-7].dval), (yyvsp[-5].dval), (yyvsp[-3].dval), (yyvsp[-1].tptr)->name, special_function.payload);
														} else
															(yyval.dval) = std::nan("0");
													} catch (const std::bad_variant_access& ex) {
														wrongArgumentInternalErrorMessage((yyvsp[-9].tptr)->name, 4);
														yynerrs++;
														return 1;
													}


												  }
#line 1475 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 15: /* expr: SPECFNCT '(' expr ')'  */
#line 260 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                         { yynerrs++; yyerrorFunction((yyvsp[-3].tptr)->name, "Argument must be a variable not an expression");}
#line 1481 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 16: /* expr: SPECFNCT '(' expr ';' expr ')'  */
#line 261 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                   { yynerrs++; yyerrorFunction((yyvsp[-5].tptr)->name, "Last argument must be a variable not an expression");}
#line 1487 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 17: /* expr: SPECFNCT '(' expr ';' expr ';' expr ')'  */
#line 262 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                           { yynerrs++; yyerrorFunction((yyvsp[-7].tptr)->name, "Last argument must be a variable not an expression");}
#line 1493 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 18: /* expr: SPECFNCT '(' expr ';' expr ';' expr ';' expr ')'  */
#line 263 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                                    { yynerrs++; yyerrorFunction((yyvsp[-9].tptr)->name, "Last argument must be a variable not an expression");}
#line 1499 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 19: /* expr: FNCT '(' ')'  */
#line 264 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     {
						const funs* function = std::get<funs*>((yyvsp[-2].tptr)->value);
						const int argc = function->argc;
						if (argc != 0) {
							wrongArgumentNumberMessage((yyvsp[-2].tptr)->name, 0, argc);
							yynerrs++;
							return 1;
						} else {
							try {
								const auto fnct_ptr = std::get<func_t>(function->fnct);
								(yyval.dval) = fnct_ptr();
							} catch (const std::bad_variant_access& ex) {
								wrongArgumentInternalErrorMessage((yyvsp[-2].tptr)->name, 0);
								yynerrs++;
								return 1;
							}
						}
					}
#line 1522 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 20: /* expr: FNCT '(' expr ')'  */
#line 282 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     {
						const funs* function = std::get<funs*>((yyvsp[-3].tptr)->value);
						const int argc = function->argc;
						if (argc != 1) {
							wrongArgumentNumberMessage((yyvsp[-3].tptr)->name, 1, argc);
							yynerrs++;
							return 1;
						} else {
							try {
								const auto fnct_ptr = std::get<func_t1>(function->fnct);
								(yyval.dval) = fnct_ptr((yyvsp[-1].dval));
							} catch (const std::bad_variant_access& ex) {
								wrongArgumentInternalErrorMessage((yyvsp[-3].tptr)->name, 1);
								yynerrs++;
								return 1;
							}
						}
					}
#line 1545 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 21: /* expr: FNCT '(' expr ',' expr ')'  */
#line 300 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                              {
								const funs* function = std::get<funs*>((yyvsp[-5].tptr)->value);
								const int argc = function->argc;
								if (argc != 2) {
									wrongArgumentNumberMessage((yyvsp[-5].tptr)->name, 2, argc);
									yynerrs++;
									return 1;
								} else {
									try {
										const auto fnct_ptr = std::get<func_t2>(function->fnct);
										(yyval.dval) = fnct_ptr((yyvsp[-3].dval),(yyvsp[-1].dval));
									} catch (const std::bad_variant_access& ex) {
										wrongArgumentInternalErrorMessage((yyvsp[-5].tptr)->name, 2);
										yynerrs++;
										return 1;
									}
								}
							}
#line 1568 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 22: /* expr: FNCT '(' expr ',' expr ',' expr ')'  */
#line 318 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                       {
										const funs* function = std::get<funs*>((yyvsp[-7].tptr)->value);
										const int argc = function->argc;
										if (argc != 3) {
											wrongArgumentNumberMessage((yyvsp[-7].tptr)->name, 3, argc);
											yynerrs++;
											return 1;
										} else {
											try {
												const auto fnct_ptr = std::get<func_t3>(function->fnct);
												(yyval.dval) = fnct_ptr((yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
											} catch (const std::bad_variant_access& ex) {
												wrongArgumentInternalErrorMessage((yyvsp[-7].tptr)->name, 3);
												yynerrs++;
												return 1;
											}
										}
									}
#line 1591 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 23: /* expr: FNCT '(' expr ',' expr ',' expr ',' expr ')'  */
#line 336 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                                {
													const funs* function = std::get<funs*>((yyvsp[-9].tptr)->value);
													const int argc = function->argc;
													if (argc != 4) {
														wrongArgumentNumberMessage((yyvsp[-9].tptr)->name, 4, argc);
														yynerrs++;
														return 1;
													} else {
														try {
															const auto fnct_ptr = std::get<func_t4>(function->fnct);
															(yyval.dval) = fnct_ptr((yyvsp[-7].dval),(yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
														} catch (const std::bad_variant_access& ex) {
															wrongArgumentInternalErrorMessage((yyvsp[-9].tptr)->name, 4);
															yynerrs++;
															return 1;
														}
													}
												}
#line 1614 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 24: /* expr: FNCT '(' expr ';' expr ')'  */
#line 354 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                              {
								const funs* function = std::get<funs*>((yyvsp[-5].tptr)->value);
								const int argc = function->argc;
								if (argc != 2) {
									wrongArgumentNumberMessage((yyvsp[-5].tptr)->name, 2, argc);
									yynerrs++;
									return 1;
								} else {
									try {
										const auto fnct_ptr = std::get<func_t2>(function->fnct);
										(yyval.dval) = fnct_ptr((yyvsp[-3].dval),(yyvsp[-1].dval));
									} catch (const std::bad_variant_access& ex) {
										wrongArgumentInternalErrorMessage((yyvsp[-5].tptr)->name, 2);
										yynerrs++;
										return 1;
									}
								}
							}
#line 1637 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 25: /* expr: FNCT '(' expr ';' expr ';' expr ')'  */
#line 372 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                       {
										const funs* function = std::get<funs*>((yyvsp[-7].tptr)->value);
										const int argc = function->argc;
										if (argc != 3) {
											wrongArgumentNumberMessage((yyvsp[-7].tptr)->name, 3, argc);
											yynerrs++;
											return 1;
										} else {
											try {
												const auto fnct_ptr = std::get<func_t3>(function->fnct);
												(yyval.dval) = fnct_ptr((yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
											} catch (const std::bad_variant_access& ex) {
												wrongArgumentInternalErrorMessage((yyvsp[-7].tptr)->name, 3);
												yynerrs++;
												return 1;
											}
										}
									}
#line 1660 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 26: /* expr: FNCT '(' expr ';' expr ';' expr ';' expr ')'  */
#line 390 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                                {
													const funs* function = std::get<funs*>((yyvsp[-9].tptr)->value);
													const int argc = function->argc;
													if (argc != 4) {
														wrongArgumentNumberMessage((yyvsp[-9].tptr)->name, 4, argc);
														yynerrs++;
														return 1;
													} else {
														try {
															const auto fnct_ptr = std::get<func_t4>(function->fnct);
															(yyval.dval) = fnct_ptr((yyvsp[-7].dval),(yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
														} catch (const std::bad_variant_access& ex) {
															wrongArgumentInternalErrorMessage((yyvsp[-9].tptr)->name, 4);
															yynerrs++;
															return 1;
														}
													}
												}
#line 1683 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 27: /* expr: FNCT '(' expr ';' expr ';' expr ';' expr ';' expr ')'  */
#line 408 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                                                         {
													const funs* function = std::get<funs*>((yyvsp[-11].tptr)->value);
													const int argc = function->argc;
													if (argc != 5) {
														wrongArgumentNumberMessage((yyvsp[-11].tptr)->name, 5, argc);
														yynerrs++;
														return 1;
													} else {
														try {
															const auto fnct_ptr = std::get<func_t5>(function->fnct);
															(yyval.dval) = fnct_ptr((yyvsp[-9].dval),(yyvsp[-7].dval),(yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
														} catch (const std::bad_variant_access& ex) {
															wrongArgumentInternalErrorMessage((yyvsp[-11].tptr)->name, 5);
															yynerrs++;
															return 1;
														}
													}
}
#line 1706 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 28: /* expr: expr '+' expr  */
#line 426 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = (yyvsp[-2].dval) + (yyvsp[0].dval);                       }
#line 1712 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 29: /* expr: expr '-' expr  */
#line 427 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = (yyvsp[-2].dval) - (yyvsp[0].dval);                       }
#line 1718 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 30: /* expr: expr "||" expr  */
#line 428 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = orFunction((yyvsp[-2].dval), (yyvsp[0].dval));            }
#line 1724 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 31: /* expr: expr '*' expr  */
#line 429 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = (yyvsp[-2].dval) * (yyvsp[0].dval);                       }
#line 1730 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 32: /* expr: expr '/' expr  */
#line 430 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = (yyvsp[-2].dval) / (yyvsp[0].dval);                       }
#line 1736 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 33: /* expr: expr '%' expr  */
#line 431 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = (int)((yyvsp[-2].dval)) % (int)((yyvsp[0].dval));         }
#line 1742 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 34: /* expr: expr "&&" expr  */
#line 432 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = andFunction((yyvsp[-2].dval), (yyvsp[0].dval));           }
#line 1748 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 35: /* expr: '!' expr  */
#line 433 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = notFunction((yyvsp[0].dval));               }
#line 1754 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 36: /* expr: expr ">=" expr  */
#line 434 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = greaterEqualThan((yyvsp[-2].dval), (yyvsp[0].dval));      }
#line 1760 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 37: /* expr: expr "<=" expr  */
#line 435 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = lessEqualThan((yyvsp[-2].dval), (yyvsp[0].dval));         }
#line 1766 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 38: /* expr: expr '>' expr  */
#line 436 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = greaterThan((yyvsp[-2].dval), (yyvsp[0].dval));           }
#line 1772 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 39: /* expr: expr '<' expr  */
#line 437 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = lessThan((yyvsp[-2].dval), (yyvsp[0].dval));              }
#line 1778 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 40: /* expr: '-' expr  */
#line 438 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = -(yyvsp[0].dval);                           }
#line 1784 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 41: /* expr: expr '^' expr  */
#line 439 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = std::pow((yyvsp[-2].dval), (yyvsp[0].dval));              }
#line 1790 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 42: /* expr: expr '*' '*' expr  */
#line 440 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = std::pow((yyvsp[-3].dval), (yyvsp[0].dval));              }
#line 1796 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 43: /* expr: '(' expr ')'  */
#line 441 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = (yyvsp[-1].dval);                            }
#line 1802 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 44: /* expr: '|' expr '|'  */
#line 442 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = std::abs((yyvsp[-1].dval));                  }
#line 1808 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;

  case 45: /* expr: expr '!'  */
#line 443 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"
                     { (yyval.dval) = gsl_sf_fact((unsigned int)(yyvsp[-1].dval)); }
#line 1814 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"
    break;


#line 1818 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/redhat-linux-build/src/gsl_parser.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (p, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, p);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, p);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (p, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, p);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, p);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 446 "/builddir/build/BUILD/LabPlot-2.11.1-build/labplot-2.11.1/src/backend/gsl/parser.ypp"


/* global symbol table (as linked list) */
symbol *symbol_table = nullptr;

int parse_errors(void) {
	return yynerrs;
}

int yyerror(param *p, const char *s) {
	/* remove trailing newline */
	p->string[strcspn(p->string, "\n")] = 0;
	printf("PARSER ERROR: %s @ position %d of string '%s'\n", s, (int)(p->pos), p->string);

	return 0;
}

/* save symbol in symbol table (at start of linked list) */
symbol* put_symbol(const char *symbol_name, int symbol_type) {
/*	pdebug("PARSER: put_symbol(): symbol_name = '%s'\n", symbol_name); */

	symbol *ptr = new symbol;
	assert(ptr);
	ptr->name = (char *)malloc(strlen(symbol_name) + 1);
	strcpy(ptr->name, symbol_name);
	ptr->type = symbol_type;
	switch (symbol_type) {
	case VAR: ptr->value = 0.; break;
	case FNCT: ptr->value = nullptr; break;
	case SPECFNCT: {
		special_function_def sfp;
		ptr->value = sfp;
		break;
	}
	}

	ptr->next = (symbol *)symbol_table;
	symbol_table = ptr;

/*	pdebug("PARSER: put_symbol() DONE\n"); */
	return ptr;
}

/* remove symbol of name symbol_name from symbol table
   removes only variables of value 0
   returns 0 on success */
int remove_symbol(const char *symbol_name) {
	symbol* ptr = symbol_table;

	/* check if head contains symbol */
	if (ptr && (strcmp(ptr->name, symbol_name) == 0)) {
		if (ptr->type == VAR && std::get<double>(ptr->value) == 0) {
			pdebug("PARSER: REMOVING symbol '%s'\n", symbol_name);
			symbol_table = ptr->next;
			free(ptr->name);
			delete ptr;
		}
		return 0;
	}

	/* search for symbol to be deleted */
	symbol* prev;
	while (ptr && (strcmp(ptr->name, symbol_name) != 0)) {
		prev = ptr;
		ptr = ptr->next;
	}

	/* symbol not found or is not a variable or is not 0 */
	if (!ptr || ptr->type != VAR || std::get<double>(ptr->value) != 0)
		return 1;

	/* remove symbol */
	pdebug("PARSER: REMOVING symbol '%s'\n", symbol_name);
	prev->next = ptr->next;
	free(ptr->name);
	delete ptr;

	return 0;
}

/* get symbol from symbol table
   returns 0 if symbol not found */
symbol* get_symbol(const char *symbol_name) {
	pdebug("PARSER: get_symbol(): symbol_name = '%s'\n", symbol_name);

	symbol *ptr;
	for (ptr = symbol_table; ptr != nullptr; ptr = (symbol *)ptr->next) {
		/* pdebug("%s ", ptr->name); */
		if (strcmp(ptr->name, symbol_name) == 0) {
			pdebug("PARSER:		SYMBOL FOUND\n");
			return ptr;
		}
	}

	pdebug("PARSER:		SYMBOL NOT FOUND\n");
	return nullptr;
}

/* initialize symbol table with all known functions and constants */
void init_table(void) {
	pdebug("PARSER: init_table()\n");

	symbol *ptr = nullptr;
	int i;
	/* add functions */
	for (i = 0; i < _number_functions; i++) {
		ptr = put_symbol(_functions[i].name, FNCT);
		ptr->value = &_functions[i];
	}
	/* add special functions */
	for (i = 0; i < _number_specialfunctions; i++) {
		ptr = put_symbol(_special_functions[i].name, SPECFNCT);

		special_function_def sfd;
		sfd.funsptr = &_special_functions[i];
		ptr->value = sfd;
	}
	/* add constants */
	for (i = 0; i < _number_constants; i++) {
		ptr = put_symbol(_constants[i].name, VAR);
		ptr->value = _constants[i].value;
	}

	pdebug("PARSER: init_table() DONE. sym_table = %p\n", ptr);
}

bool set_specialfunction0(const char* function_name, func_tPayload function, std::weak_ptr<Payload> payload) {
	pdebug("PARSER: set_SpecialFunction0()\n");


	symbol *ptr = get_symbol(function_name);
	if (!ptr) // function name not found
		return false;

	assert(std::get<special_function_def>(ptr->value).funsptr->argc == 0);
	std::get<special_function_def>(ptr->value).funsptr->fnct = function;
	std::get<special_function_def>(ptr->value).funsptr->name = function_name;
	std::get<special_function_def>(ptr->value).payload = payload;
	return true;
}

bool set_specialfunction1(const char* function_name, func_t1Payload function, std::shared_ptr<Payload> payload) {
	pdebug("PARSER: set_SpecialFunction1()\n");


	symbol *ptr = get_symbol(function_name);
	if (!ptr) // function name not found
		return false;
	assert(std::get<special_function_def>(ptr->value).funsptr->argc == 1);
	std::get<special_function_def>(ptr->value).funsptr->fnct = function;
	std::get<special_function_def>(ptr->value).funsptr->name = function_name;
	std::get<special_function_def>(ptr->value).payload = payload;
	return true;
}

bool set_specialfunction2(const char* function_name, func_t2Payload function, std::shared_ptr<Payload> payload) {
	pdebug("PARSER: set_SpecialFunction2()\n");


	symbol *ptr = get_symbol(function_name);
	if (!ptr) // function name not found
		return false;

	assert(std::get<special_function_def>(ptr->value).funsptr->argc == 2);
	std::get<special_function_def>(ptr->value).funsptr->fnct = function;
	std::get<special_function_def>(ptr->value).funsptr->name = function_name;
	std::get<special_function_def>(ptr->value).payload = payload;
	return true;
}

bool set_specialfunction3(const char* function_name, func_t3Payload function, std::shared_ptr<Payload> payload) {
	pdebug("PARSER: set_SpecialFunction3()\n");


	symbol *ptr = get_symbol(function_name);
	if (!ptr) // function name not found
		return false;

	assert(std::get<special_function_def>(ptr->value).funsptr->argc == 3);
	std::get<special_function_def>(ptr->value).funsptr->fnct = function;
	std::get<special_function_def>(ptr->value).funsptr->name = function_name;
	std::get<special_function_def>(ptr->value).payload = payload;
	return true;
}

bool set_specialfunction4(const char* function_name, func_t4Payload function, std::shared_ptr<Payload> payload) {
	pdebug("PARSER: set_SpecialFunction4()\n");


	symbol *ptr = get_symbol(function_name);
	if (!ptr) // function name not found
		return false;

	assert(std::get<special_function_def>(ptr->value).funsptr->argc == 4);
	std::get<special_function_def>(ptr->value).funsptr->fnct = function;
	std::get<special_function_def>(ptr->value).funsptr->name = function_name;
	std::get<special_function_def>(ptr->value).payload = payload;
	return true;
}

void delete_table(void) {
	pdebug("PARSER: delete_table()\n");
	while(symbol_table) {
		symbol *tmp = symbol_table;
		symbol_table = symbol_table->next;
		free(tmp->name);
		free(tmp);
	}
}

/* add new symbol with value or just set value if symbol is a variable */
symbol* assign_symbol(const char* symbol_name, double value) {
	pdebug("PARSER: assign_symbol() : symbol_name = '%s', value = %g\n", symbol_name, value);

	/* be sure that the symbol table has been initialized */
	if (!symbol_table)
		init_table();

	symbol* ptr = get_symbol(symbol_name);
	if (!ptr) {
		pdebug("PARSER: calling putsymbol(): symbol_name = '%s'\n", symbol_name);
		ptr = put_symbol(symbol_name, VAR);
	} else {
		pdebug("PARSER: Symbol already assigned\n");
	}

	/* do not assign value if symbol already exits as function */
	if (ptr->type == VAR)
		ptr->value = value;

	return ptr;
}

static int getcharstr(param *p) {
	pdebug(" getcharstr() pos = %d\n", (int)(p->pos));

	if (p->string[p->pos] == '\0')
		return EOF;
	/* pdebug("PARSER: 	char is %c\n", p->string[p->pos]); */
	return p->string[(p->pos)++];
}

static void ungetcstr(size_t *pos) {
	/* pdebug("PARSER: ungetcstr()\n"); */
	if (*pos > 0)
		(*pos)--;
}

double parse(const char* string, const char* locale) {
	pdebug("\nPARSER: parse('%s') len = %d\n********************************\n", string, (int)strlen(string));

	/* be sure that the symbol table has been initialized */
	if (!symbol_table)
		init_table();

	_variablesCounter = 0;
	_lastErrorMessage[0] = 0;

	param p;
	p.pos = 0;
	p.locale = locale;

	/* leave space to terminate string by "\n\0" */
	const size_t slen = strlen(string) + 2;
	p.string = (char *) malloc(slen * sizeof(char));
	if (p.string == nullptr) {
		printf("PARSER ERROR: Out of memory for parsing string\n");
		return 0.;
	}

	strcpy(p.string, string);
	p.string[strlen(string)] = '\n';	// end for parsing
	p.string[strlen(string)+1] = '\0';	// end of string
	/* pdebug("PARSER: Call yyparse() for \"%s\" (len = %d)\n", p.string, (int)strlen(p.string)); */

	/* parameter for yylex */
	res = NAN;	/* default value */
	yynerrs = 0;	/* reset error count */
	yyparse(&p);

	pdebug("PARSER: parse() DONE (result = %g, errors = %d)\n*******************************\n", res, parse_errors());
	free(p.string);
	p.string = nullptr;

	return res;
}

double parse_with_vars(const char *str, const parser_var *vars, int nvars, const char* locale) {
	pdebug("\nPARSER: parse_with_var(\"%s\") len = %d\n", str, (int)strlen(str));

	int i;
	for(i = 0; i < nvars; i++) {	/*assign vars */
		pdebug("PARSER: Assign '%s' the value %g\n", vars[i].name, vars[i].value);
		assign_symbol(vars[i].name, vars[i].value);
	}

	return parse(str, locale);
}

int yylex(param *p) {
	pdebug("PARSER: YYLEX()");

	/* get char and skip white space */
	int c;
	while ((c = getcharstr(p)) == ' ' || c == '\t');

	/* finish if reached EOF */
	if (c == EOF) {
		pdebug("PARSER: FINISHED\n");
		return 0;
	}
	/* check for non-ASCII chars */
	if (!isascii(c)) {
		pdebug(" non-ASCII character found. Giving up\n");
		yynerrs++;
		return 0;
	}
	if (c == '\n') {
		pdebug("PARSER: Reached EOL\n");
		return c;
	}

	if (c == '&') {
		// Check if the next is also an &, because then it is the AND operator
		if (getcharstr(p) == '&') {
			return AND;
		}
		ungetcstr(&(p->pos));
	} else if (c == '|') {
		if (getcharstr(p) == '|') {
			return OR;
		}
		ungetcstr(&(p->pos));
	} else if (c == '>') {
		if (getcharstr(p) == '=') {	// >=
			return GE;
		}
		ungetcstr(&(p->pos));
	} else if (c == '<') {
		if (getcharstr(p) == '=') {	// <=
			return LE;
		}
		ungetcstr(&(p->pos));
	}

	pdebug("PARSER: PROCESSING character '%c'\n", c);

	/* process numbers */
	if (isdigit(c)) {
		pdebug("PARSER: Found NUMBER (starts with digit)\n");
                ungetcstr(&(p->pos));
                char *s = &(p->string[p->pos]);

		/* convert to double */
		char *remain;
#if defined(_WIN32)
		locale_t locale = _create_locale(LC_NUMERIC, p->locale);
		if (locale == NULL) {
			pdebug("PARSER ERROR in newlocale(%s): %s. Trying system locale.\n", p->locale, strerror(errno));
			locale = _create_locale(LC_NUMERIC, "");
		}
#else
		locale_t locale = newlocale(LC_NUMERIC_MASK, p->locale, (locale_t)nullptr);
		if (locale == (locale_t)nullptr) {
			pdebug("PARSER ERROR in newlocale(%s): %s. Trying system locale.\n", p->locale, strerror(errno));
			locale = newlocale(LC_NUMERIC_MASK, "", (locale_t)nullptr);
			pdebug("PARSER:		Reading: '%s' with system locale\n", s);
		} else {
			pdebug("PARSER:		Reading: '%s' with locale %s\n", s, p->locale);
		}
#endif
		double result;
		if (locale != nullptr) {
#if defined(__OpenBSD__) || defined(__HAIKU__)
			result = strtod(s, &remain);
#else
			result = strtod_l(s, &remain, locale);
#endif
			freelocale(locale);
		} else // use C locale
			result = strtod(s, &remain);

		pdebug("PARSER:		Remain: '%s'\n", remain);

		/* check conversion */
		if(strlen(s) == strlen(remain))
			return 0;

		pdebug("PARSER:		Result = %g\n", result);
		yylval.dval = result;

                p->pos += strlen(s) - strlen(remain);

		return NUM;
	}

	/* process symbol */
	if (isalpha (c) || c == '.') {
		pdebug("PARSER: Found SYMBOL (starts with alpha)\n");
		static char *symbol_name = nullptr;
		static int length = 0;
		int i = 0;

		/* Initially make the buffer long enough for a 10-character symbol name */
		if (length == 0) {
			length = 10;
			symbol_name = (char *) malloc(length + 1);
		}

		do {
			pdebug("PARSER: Reading symbol .. ");
			/* If buffer is full, make it bigger */
			if (i == length) {
				length *= 2;
				symbol_name = (char *) realloc(symbol_name, length + 1);
			}
			symbol_name[i++] = c;
			c = getcharstr(p);
			pdebug("PARSER:		got '%c'\n", c);
		}
		while (c != EOF && (isalnum(c) || c == '_' || c == '.'));
		pdebug("PARSER: Reading SYMBOL DONE\n");

		if (c != EOF)
			ungetcstr(&(p->pos));
		symbol_name[i] = '\0';

		symbol *s = get_symbol(symbol_name);
		if(s == nullptr) {	/* symbol unknown */
			pdebug("PARSER ERROR: Symbol '%s' UNKNOWN\n", symbol_name);
			yynerrs++;
			return 0;
			/* old behavior: add symbol */
			/* s = put_symbol(symbol_name, VAR); */
		}

		yylval.tptr = s;
		return s->type;
	}

	/* else: single operator */
	pdebug("PARSER: Found single operator '%c'\n", c);
	return c;
}
